import * as vscode from "vscode";
import { Program, Node } from "@typescript-eslint/typescript-estree/dist/ts-estree/ts-estree";
export declare function activate(context: vscode.ExtensionContext): void;
export declare function onUpdatedAST(updatedCallback: UpdatedAST): void;
declare type DecorationIntersection = (Omit<vscode.DecorationRenderOptions & vscode.DecorationInstanceRenderOptions, "range"> & ({
    range: vscode.Range;
} | {
    node: Node;
}) & {
    hoverMessage?: vscode.DecorationOptions["hoverMessage"];
});
export declare function updateDecorations(editor: vscode.TextEditor): Promise<void>;
export declare type UpdatedAST = {
    (config: {
        ast: Program;
        doc: vscode.TextDocument;
        setDecoration: (decoration: DecorationIntersection) => void;
        traverse: (config: {
            enter: (statement: Node, parent?: Node, property?: string) => "stop" | "skipSiblings" | "ignore" | void;
            exit?: (statement: Node, parent?: Node, property?: string) => void;
        }) => void;
    }): Promise<void> | void;
};
import "./decorationSetup";
export {};
