import { LineAndColumnData, Program } from "@typescript-eslint/typescript-estree/dist/ts-estree/ts-estree";
import { UpdatedAST } from "./extension";
export interface ScopeObj {
    posStart: number;
    posLineCol: LineAndColumnData;
    scopeName: string;
    parentFncScope: ScopeObj | null;
    parentScope: ScopeObj | undefined;
    variables: Map<string, DeclObj>;
    type: "function" | "brace";
}
export interface DeclObj {
    varName: string;
    varPos: number;
    uses: Set<number>;
}
export declare function parseClosed(code: string, onDeclare: (obj: DeclObj, scope: ScopeObj) => void, onAccess: (declScope: ScopeObj | undefined, varName: string, varPos: number, curScope: ScopeObj, curFncScope: ScopeObj, declObj: DeclObj | undefined) => void, traverse: Parameters<UpdatedAST>[0]["traverse"]): Program;
